
fLayer struct
	DC dword 0
	bmp dword 0
fLayer ends

literal_double		macro	lit_double:vararg
			local	local_double

			.data
local_double		real8	lit_double

			.code
			exitm	<local_double>
			endm
			
literal_float		MACRO	lit_float:VARARG
			LOCAL	local_float
			.data
local_float		real4	lit_float
			.code
			EXITM	<local_float>
			ENDM

CFLT			MACRO	lit_float:VARARG
			EXITM	<literal_float(lit_float)>
			ENDM
			
CTEXT MACRO y:VARARG
	LOCAL sym

	CONST segment
		IFIDNI <y>,<>
			sym db 0
		ELSE
			sym db y,0
		ENDIF
	CONST ends

	EXITM <OFFSET sym>
ENDM

CDBL			macro	lit_double:vararg
			exitm	<literal_double(lit_double)>
			endm
			
literal_string		macro	lit_string
			local	local_string

			.data
			align	4
local_string		db	lit_string, 0

			.code
			exitm	<local_string>
			endm
CSTR			macro	lit_string
			exitm	<offset literal_string(lit_string)>
			endm

.code

mAlloc proc nSize:dword
	
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,nSize
	.if eax==0
		invoke MessageBox,NULL,CADD("Memory Allocation Error"),NULL,MB_OK
	.endif
	
	ret
mAlloc endp

Open proc lpBuffer:dword,lpFileName:dword,lpSize:dword,_size:dword
  LOCAL hfile:dword
  
 invoke CreateFile,lpFileName,GENERIC_READ ,FILE_SHARE_READ ,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,NULL
 mov hfile,eax
 invoke ReadFile,hfile,lpBuffer,_size,lpSize,NULL  
 invoke CloseHandle,hfile	
 
 ret
Open endp

PERR	PROC uses ebx edi esi	;, _API : DWORD
LOCAL	szMsgBuf[500]:BYTE

	INVOKE GetLastError
	mov	ebx, eax
	INVOKE FormatMessage, \
		FORMAT_MESSAGE_FROM_SYSTEM,\
		NULL, \
		ebx, \					;Message Id
		LANG_NEUTRAL + SUBLANG_DEFAULT*1024, \	;Message language
		ADDR szMsgBuf, \			;Buffer to store message
		500, \					;Buffer size
		NULL					;No more arguments
	INVOKE	MessageBox, NULL, ADDR szMsgBuf, NULL, MB_OK

	;INVOKE	ExitProcess, -1

	ret

PERR	ENDP

fCenterWindows proc hWnd:dword,_width:dword,height:dword
	LOCAL xs,ys:dword
	LOCAL hxs,hys:dword
	
	invoke GetSystemMetrics,SM_CXSCREEN
	mov xs,eax
	shr eax,1
	mov hxs,eax
	invoke GetSystemMetrics,SM_CYSCREEN
	mov ys,eax
	shr eax,1
	mov hys,eax
	
	mov eax,_width
	shr eax,1
	sub hxs,eax
	
	mov eax,height
	shr eax,1
	sub hys,eax
	
	invoke SetWindowPos,hWnd,HWND_NOTOPMOST,hxs,hys,_width,height,NULL
	
	ret
fCenterWindows endp

